function un1=CEPasso(un,dt,dx,var)
%
% un vettore colonna, dt e dx scalari, var variabile
% di controllo che sceglie l'algoritmo risolutivo
% Risoluzione dell'equazione del calore u_t=u_xx
% La derivata seconda in x viene approssimata con
% differenze centrali, il risultante sistema di ODE viene 
% approssimato tramite il metodo di Eulero esplicito.
%
% var e' una variabile di controllo che se settata a 1
% forza la routine ad utilizzare la struttura meno
% efficiente di prodotto matrice-vettore.
%
if nargin==3
   var=0;
end
lambda=dt/(dx^2);
N=length(un);
if var == 0 
   un1(1)=un(1);
   un1(N)=un(N);
   for i=2:N-1
      un1(i)=un(i)*(1-2*lambda)+lambda*(un(i-1)+un(i+1));
   end
elseif var == 1
   A=zeros(N,N);
   A(1,1)=1; A(N,N)=1;
   for i=2:N-1 
      A(i,i)=1-2*lambda;
      A(i,i+1)=lambda;
      A(i,i-1)=lambda;
   end
   un1=A*un;
end
