function un1=CIPasso(un,dt,dx,bl,br,var)
%
% un, bl, br vettori colonna, dt e dx scalari, var variabile
% di controllo che sceglie l'algoritmo risolutivo
% Risoluzione dell'equazione del calore u_t=u_xx
% La derivata seconda in x viene approssimata con
% differenze centrali, il risultante sistema di ODE viene 
% approssimato tramite il metodo di Eulero implicito.
%
% bl, br sono vettori a sei dimensioni che definiscono 
% le condizioni al bordo, se omessi i valori al bordo 
% restano invariati.
%
% var e' una variabile di controllo che se settata a 1 
% forza la routine ad utilizzare l'algoritmo 
% basato sull'operatore '\' di Matlab 
%
lambda=dt/(dx^2);
N=length(un);
if nargin==3
   var=0;
   bl = [1,0,0,-lambda,1+2*lambda,-lambda];
   br = [-lambda,1+2*lambda,-lambda,0,0,1];
elseif nargin==4
   bl = [1,0,0,-lambda,1+2*lambda,-lambda];
   br = [-lambda,1+2*lambda,-lambda,0,0,1];
elseif nargin==5 
   var=0;
end

if var == 0 
   b(1)=bl(1); b(N)=br(6);
   c(1)=bl(2); a(N)=br(5);
   a(2)=bl(4); c(N-1)=br(3);
   b(2)=bl(5); b(N-1)=br(2);
   c(2)=bl(6); a(N-1)=br(1);
   
   for i=3:N-2 
      b(i)=1+2*lambda;
      c(i)=-lambda;
      a(i)=-lambda;
   end
   un1 = tridiag(a,b,c,un);
elseif var == 1
   A=zeros(N,N);
   A(1,1)=bl(1); A(N,N)=br(6);
   A(2,1)=bl(4); A(2,2)=bl(5); A(2,3)=bl(6);
   A(N-2,N-1)=br(1); A(N-1,N-1)=br(2); A(N,N-1)=br(3);

   for i=3:N-2 
      A(i,i)=1+2*lambda;
      A(i,i+1)=-lambda;
      A(i,i-1)=-lambda;
   end
   un1=A\un;
end
