% Script file: CaloreImplicito.m
%
% Risoluzione del problema ai valori iniziali per l'equazione del 
% calore 
%            u_t = u_xx,  x in [0,L] 
% tramite il metodo delle linee.
% Lo script utilizza la funzione un1=CIPasso(un,dt,dx,val)
% Il dato iniziale e' 
%               u(x,0)=1 per 0 < x < L/2
%               u(x,0)=0 per L/2 < x < L
% con condizioni al bordo di Dirichlet u(0,t)=1, u(L,t)=0.

close all;
clear; clc;
L = 1;
N = 20;
N2 = N/2 ;
dx = L/(N-1);
t = input('Inserisci il tempo finale : ');
dt = input('Inserisci il passo dt     : ');
u(1:N2)=1.0;
u(N2+1:N)=0.0;
u=u';
x=linspace(0,L,N);
plot(x,u,'r')
xlabel('x')
ylabel('u(x,t)')
title('Distribuzione iniziale della temperatura:'); 
pause(1)
tc = 0 ;
while tc < t 
   u=CIPasso(u,dt,dx);
   tc = tc + dt ;
   plot(x,u,'g')
   s=sprintf('Evoluzione della temperatura al tempo t=%f',tc);
   title(s);
   xlabel('x')
   ylabel('u(x,t)')
   pause(0.1)
end